﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Silverlight.Controls;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace xamwebgridsample
{
    public partial class MainPage : UserControl
    {
        private GroupStaff fullList = new GroupStaff();

        public MainPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            //create some dummy data
            this.getData();
            this.mainDataGrid.DataContext = this.fullList;
        }

        private void getData()
        {
            this.fullList.Staff = new ObservableCollection<GroupStaff>();

            GroupStaff parent = new GroupStaff { Level = 1, Name = "Top", PctChange = 0, Rate = 200, Total = 200, Staff = new ObservableCollection<GroupStaff>(), IsSelected = false };

            GroupStaff child = new GroupStaff { Level = 2, Name = "child", PctChange = 0, Rate = 150, Total = 150, IsSelected = false };

            parent.Staff.Add(child);

            child = new GroupStaff() { Level = 2, Name = "child2", PctChange = 0, Rate = 125, Total = 150, IsSelected = false };

            parent.Staff.Add(child);

            this.fullList.Staff.Add(parent);

            parent = new GroupStaff { Level = 1, Name = "Top2", PctChange = 0, Rate = 200, Total = 200, Staff = new ObservableCollection<GroupStaff>(), IsSelected = false };

            child = new GroupStaff { Level = 2, Name = "child3", PctChange = 0, Rate = 150, Total = 150, IsSelected = false };

            parent.Staff.Add(child);

            child = new GroupStaff() { Level = 2, Name = "child4", PctChange = 0, Rate = 125, Total = 150, IsSelected = false };

            parent.Staff.Add(child);

            this.fullList.Staff.Add(parent);
            
        }

        private void mainDataGrid_ColumnLayoutAssigned(object sender, Infragistics.Silverlight.ColumnLayoutAssignedEventArgs e)
        {
            if (e.ColumnLayout.Columns.Count == 0)
            {
                //this defines a style that does the indent, style applied to first column
                Style cellStyle = new Style(typeof(CellControl));
                cellStyle.Setters.Add(new Setter(Control.PaddingProperty, new Thickness(5 + (e.Level * 16), 2, 2, 2)));

                TemplateColumn SelectedColumn = new TemplateColumn() { Key = "IsSelected", Width = new ColumnWidth() };
                SelectedColumn.ItemTemplate = this.Resources["IsSelectedColumnContent"] as DataTemplate;

                TemplateColumn NameColumn = new TemplateColumn() { Key = "Name", Width = new ColumnWidth(), CellStyle = cellStyle, HeaderText = "Name" };

                NameColumn.MaximumWidth = 170;
                NameColumn.ItemTemplate = this.Resources["NameColumnContent"] as DataTemplate;
                NameColumn.EditorTemplate = this.Resources["NameColumnContent"] as DataTemplate;

                TemplateColumn RateColumn = new TemplateColumn() { Key = "Rate", Width = new ColumnWidth(), HeaderText = "Rate"};
                RateColumn.ItemTemplate = this.Resources["RateColumnContent"] as DataTemplate;
                RateColumn.EditorTemplate = this.Resources["RateColumnContent"] as DataTemplate;

                ////this defines a ChildRowBand that will have the same layout as the columns defined above. 
                ColumnLayout StaffColumnLayout = new ColumnLayout() { Key = "Staff", HeaderVisibility = Visibility.Collapsed };

                e.ColumnLayout.Columns.Add(SelectedColumn);
                e.ColumnLayout.Columns.Add(NameColumn);
                e.ColumnLayout.Columns.Add(RateColumn);

                ////and the child row band
                e.ColumnLayout.Columns.Add(StaffColumnLayout);

            }
        }

        private void NameTextBox_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Add)
            {
                //(sender as TextBox).Text += "+";
                //
                
               // e.Handled = true;
            }
        }

    }

    public class GroupStaff : INotifyPropertyChanged
    {
        public string Name { get; set; }
        public decimal Rate { get; set; }
        public decimal PctChange { get; set; }
        public decimal Total { get; set; }
        public ObservableCollection<GroupStaff> Staff { get; set; }
        public int Level { get; set; }
        public bool IsSelected { get; set; }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
    }
}
